package at.ac.tuwien.dbai.staff.dvorak.alternation.examples;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationNode;
import at.ac.tuwien.dbai.staff.dvorak.alternation.runtime.ComputationTree;

public class OneDimensionalCellularAutomataTest {

	private static void addRule(Map<List<Character>,Character> rphi,  List<Character> oldstates ,char newstate){
		rphi.put(oldstates, newstate);
	}

	private static void addSimpleRule(Map<List<Character>,Character> rphi, char left, char oldstate, char right,char newstate){
		List<Character> oldstates =new ArrayList<Character>();
		oldstates.add(left);
		oldstates.add(oldstate);
		oldstates.add(right);
		addRule(rphi,oldstates, newstate);
	}

	private static void addLiteral(Map<Character,Set<Set<Character>>> rules, char head){
		if (!rules.containsKey(head)){
			rules.put(head, new HashSet<Set<Character>>());
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		char[] cells = new char[]{'1','1','0','1','1','0','1','0','1','1','0','1','1','1','1',};
		int cell=10;
		char finalstate='0';
		int T=30;
		Byte r=1;
		Map<List<Character>,Character> rphi=new HashMap<List<Character>,Character>();
		addSimpleRule(rphi,'0','0','0','0');
		addSimpleRule(rphi,'0','0','1','0');
		addSimpleRule(rphi,'0','1','0','0');
		addSimpleRule(rphi,'0','1','1','1');
		addSimpleRule(rphi,'1','0','0','0');
		addSimpleRule(rphi,'1','0','1','1');
		addSimpleRule(rphi,'1','1','0','1');
		addSimpleRule(rphi,'1','1','1','0');

		addSimpleRule(rphi,'b','0','0','0');
		addSimpleRule(rphi,'b','0','1','0');
		addSimpleRule(rphi,'b','1','0','0');
		addSimpleRule(rphi,'b','1','1','1');

		addSimpleRule(rphi,'0','0','b','0');
		addSimpleRule(rphi,'1','0','b','0');
		addSimpleRule(rphi,'0','1','b','0');
		addSimpleRule(rphi,'1','1','b','1');

		addSimpleRule(rphi,'b','b','0','b');
		addSimpleRule(rphi,'b','b','1','b');
		addSimpleRule(rphi,'0','b','b','b');
		addSimpleRule(rphi,'1','b','b','b');

		addSimpleRule(rphi,'b','b','b','b');

		OneDimensionalCellularAutomata atm = new OneDimensionalCellularAutomata();
	    System.out.println(atm.compute(cells,cell, finalstate, T,r,rphi));
		System.out.println("#ComputationNodes: "+ atm.getComputationTree().size());
		ComputationTree<OneDimensionalCellularAutomata.Worktape>  cT =atm.getComputationTree();
		
	}


}
